include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "relations.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O.
definition eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
definition pred : nat -> nat := \lambda n : nat. (match_nat_type) (nat) (O)  (\lambda p : nat. p) n.
axiom le : nat -> nat -> Prop.
axiom le_n : \forall (n:nat). (le)  n n.
axiom le_S : \forall (n:nat). \forall (m:nat). ((le)  n m) -> (le)  n ((S)  m).
axiom le_ind : \forall (n:nat). \forall (Q:nat -> Prop). (Q n) -> (\forall (m:nat). ((le)  n m) -> (Q m) -> Q ((S)  m)) -> \forall (m:nat). ((le)  n m) -> Q m.
definition le_n_Sn : \forall (n:nat). (le)  n ((S)  n) := \lambda n : nat. (((le_S) (n)) (n)) ((le_n) (n)).
definition transitive_le : (transitive) (nat) (le)  := \lambda a : nat. \lambda b : nat. \lambda c : nat. \lambda leab : (le)  a b. (\lambda lebc : (le)  b c. (((((((le_ind) (b)) (\lambda x_417 : nat. (le)  a x_417)) (leab)) (\lambda m : nat. \lambda j_x_419 : (le)  b m. (\lambda j_x_421 : (le)  a m. ((((le_S) (a)) (m)) (j_x_421))))) (c)) (lebc))).
definition le_pred_n : \forall (n:nat). (le)  ((pred)  n) n := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. (le)  ((pred)  j_x_365) j_x_365)) ((((((eq_match_nat_type_O) (nat)) ((O) )) (\lambda p : nat. p)) (\lambda y : nat. (le)  ((match_nat_type) (nat) (O)  (\lambda p : nat. p) (O) ) y)) ((le_n) ((pred)  (O) )))) (\lambda x_366 : nat. \lambda j_x_368 : (le)  ((pred)  x_366) x_366. (((((((eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (x_366)) (\lambda y : nat. (le)  ((pred)  ((S)  x_366)) ((S)  y))) ((le_n_Sn) ((pred)  ((S)  x_366)))))) (n).
definition monotonic_pred : (monotonic) (nat) (le)  (pred)  := \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (((((((le_ind) (n)) (\lambda x_417 : nat. (le)  ((pred)  n) ((pred)  x_417))) ((le_n) ((pred)  n))) (\lambda m0 : nat. \lambda j_x_419 : (le)  n m0. (\lambda j_x_421 : (le)  ((pred)  n) ((pred)  m0). ((((((transitive_le) ((pred)  n)) (n)) ((pred)  ((S)  m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (m0)) (\lambda y : nat. (le)  n y)) (j_x_419)))))) (m)) (lenm)).
